package server;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class TestServer extends Server {

	private Gui g;


	public TestServer(int port) {
		super(port);
		System.out.println(this.toString());
		System.out.println("* Listening ...");
		this.g = new Gui(this);
	}
	
	public void gui() {
		this.g.initGUI();
		this.g.append("* Server started ...\r\n    " + this.toString());
	}

	public void closed(String ipAdresse, int port) {
		System.out.println("* Closed Conn.: " + ipAdresse + "/" + port);
		this.g.append("<< Closed Conn.: " + ipAdresse + "/" + port);
	}

	public void newcome(String ipAdresse, int port) {
		System.out.println("* New Conn.: " + ipAdresse + "/" + port);
		this.g.append(">> New Conn.: " + ipAdresse + "/" + port);
	}

	public void income(String ipAdresse, int port, String transmission) {
		System.out.println("* New Transm.: " + ipAdresse + "/" + port + ": " + transmission);
		this.g.append(">> New Trans.: " + ipAdresse + "/" + port + "\r\n    " + transmission);
	}
	
	public static void main(String[] args) {
		TestServer t = new TestServer(1234);
		t.gui();
	}
	
	public class Gui extends JFrame {
		
		private static final long serialVersionUID = 1L;
		private JTextArea ta;
		private JTextField ip;
		private JTextField port;
		private JTextField message;
		private TestServer ts;

		public Gui(TestServer ts) {
			this.ts = ts;
		}
		
		public void initGUI() {
			try {
				this.setTitle("Test-Server");
				this.setLayout(new BorderLayout());
					ta = new JTextArea();
					ta.setEditable(false);
				this.add(new JScrollPane(ta), BorderLayout.CENTER);
					JPanel bottom = new JPanel();
					bottom.setPreferredSize(new Dimension(0, 50));
					ip = new JTextField();
					ip.setColumns(13);
					port = new JTextField();
					port.setColumns(4);
					message = new JTextField();
					message.setColumns(20);
					bottom.add(ip);
					bottom.add(port);
					bottom.add(message);
					JButton send = new JButton("Senden");
					send.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent arg0) {
							send();
						}
					});
					bottom.add(send);
				this.add(bottom, BorderLayout.SOUTH);
				this.pack();
				this.setSize(600, 400);
				this.setVisible(true);
			} catch (Exception e) {
				System.out.println(e.toString());
			}
		}
		
		public void send() {
			this.ts.send(
					this.ip.getText(),
					Integer.parseInt(this.port.getText()),
					this.message.getText()
			);
		}
		
		public void append(String s) {
			this.ta.append(s + "\r\n");
		}
		
	}
	
}
